# NatPunchthroughClient Class Reference
[NatPunchthrough]

`#include <NatPunchthroughClient.h>`

Inheritance diagram for NatPunchthroughClient:

List of all members.

## Public Member Functions

void | SetDebugInterface (NatPunchthroughDebugInterface *i)
virtual void | Update (void)
| Update is called every time a packet is checked for .
virtual PluginReceiveResult | OnReceive (Packet *packet)
virtual void | OnNewConnection (SystemAddress systemAddress, RakNetGUID rakNetGUID, bool isIncoming)
virtual void | OnClosedConnection (SystemAddress systemAddress, RakNetGUID rakNetGUID, PI2_LostConnectionReason lostConnectionReason)
virtual void | OnAttach (void)
virtual void | OnDetach (void)
virtual void | OnShutdown (void)
| Called when RakPeer is shutdown.

## Detailed Description

Maintain connection to NatPunchthroughServer to process incoming connection attempts through NatPunchthroughClient Client will send datagrams to port to estimate next port Will simultaneously connect with another client once ports are estimated.

## Member Function Documentation

void NatPunchthroughClient::OnAttach | ( | void |  | ) | `[virtual]`

Called when the interface is attached

Parameters:

  `[in]` | peer | the instance of RakPeer that is calling Receive

Reimplemented from PluginInterface2.

void NatPunchthroughClient::OnClosedConnection | ( | SystemAddress | systemAddress,
|  | RakNetGUID | rakNetGUID,
|  | PI2_LostConnectionReason | lostConnectionReason |
| ) |  |  | `[virtual]`

Called when a connection is dropped because the user called RakPeer::CloseConnection() for a particular system

Parameters:

  `[in]` | systemAddress | The system whose connection was closed
  `[in]` | rakNetGuid | The guid of the specified system
  `[in]` | lostConnectionReason | How the connection was closed: manually, connection lost, or notification of disconnection

Reimplemented from PluginInterface2.

void NatPunchthroughClient::OnDetach | ( | void |  | ) | `[virtual]`

Called when the interface is detached

Parameters:

  `[in]` | peer | the instance of RakPeer that is calling Receive

Reimplemented from PluginInterface2.

void NatPunchthroughClient::OnNewConnection | ( | SystemAddress | systemAddress,
|  | RakNetGUID | rakNetGUID,
|  | bool | isIncoming |
| ) |  |  | `[virtual]`

Called when we got a new connection

Parameters:

  `[in]` | systemAddress | Address of the new connection
  `[in]` | rakNetGuid | The guid of the specified system
  `[in]` | isIncoming | If true, this is ID_NEW_INCOMING_CONNECTION, or the equivalent

Reimplemented from PluginInterface2.

PluginReceiveResult NatPunchthroughClient::OnReceive | ( | Packet * | packet | ) | `[virtual]`

OnReceive is called for every packet.

Parameters:

  `[in]` | packet | the packet that is being returned to the user

Returns:
  True to allow the game and other plugins to get this message, false to absorb it

Reimplemented from PluginInterface2.

void NatPunchthroughClient::SetDebugInterface | ( | NatPunchthroughDebugInterface * | i | ) |

Sets a callback to be called with debug messages

Parameters:

  `[in]` | i | Pointer to an interface. The pointer is stored, so don't delete it while in progress. Pass 0 to clear.

The documentation for this class was generated from the following files:

- C:/RakNet/Source/NatPunchthroughClient.h
- C:/RakNet/Source/NatPunchthroughClient.cpp